VERSION 5.00
Object = "{648A5603-2C6E-101B-82B6-000000000014}#1.1#0"; "mscomm32.ocx"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   2310
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   2310
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.ComboBox cboCommPort 
      Height          =   315
      ItemData        =   "Form1.frx":0000
      Left            =   2040
      List            =   "Form1.frx":0010
      Style           =   2  'Dropdown List
      TabIndex        =   5
      Top             =   1200
      Width           =   735
   End
   Begin MSCommLib.MSComm MSComm1 
      Left            =   3480
      Top             =   1680
      _ExtentX        =   1005
      _ExtentY        =   1005
      _Version        =   393216
      DTREnable       =   -1  'True
   End
   Begin VB.TextBox txtPhoneNumber 
      Height          =   285
      Left            =   2040
      TabIndex        =   2
      Top             =   840
      Width           =   1695
   End
   Begin VB.CommandButton cmdDial 
      Caption         =   "Dial"
      Height          =   375
      Left            =   2040
      TabIndex        =   0
      Top             =   1800
      Width           =   615
   End
   Begin VB.Label Label1 
      Caption         =   "Comm Port"
      Height          =   255
      Index           =   1
      Left            =   840
      TabIndex        =   4
      Top             =   1200
      Width           =   1095
   End
   Begin VB.Label Label2 
      Alignment       =   2  'Center
      Caption         =   "To test, enter your phone number and verify that you get a busy signal."
      Height          =   495
      Left            =   240
      TabIndex        =   3
      Top             =   240
      Width           =   4215
   End
   Begin VB.Label Label1 
      Caption         =   "Phone Number"
      Height          =   255
      Index           =   0
      Left            =   840
      TabIndex        =   1
      Top             =   840
      Width           =   1095
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
' Clean the phone number, remove extraneous characters
' like - and (, and convert letters into digits.
Private Function CleanPhoneNumber(ByVal phone_number As String) As String
Dim result As String
Dim i As Integer

    For i = 1 To Len(phone_number)
        result = result & PhoneDigit(Mid$(phone_number, i, 1))
    Next i

    CleanPhoneNumber = result
End Function

' If "letter" is number, return it unchanged.
' If "letter" is a letter, return the corresponding
' telephone digit.
' If "letter" is something else, return "".
Private Function PhoneDigit(ByVal letter As String) As String
    letter = UCase(letter)

    If letter >= "0" And letter <= "9" Then
        PhoneDigit = letter
    ElseIf letter >= "A" And letter <= "Z" Then
        Select Case letter
            Case "A" To "C"
                PhoneDigit = 2
            Case "D" To "F"
                PhoneDigit = 3
            Case "G" To "I"
                PhoneDigit = 4
            Case "J" To "L"
                PhoneDigit = 5
            Case "M" To "O"
                PhoneDigit = 6
            Case "P" To "S"
                PhoneDigit = 7
            Case "T" To "V"
                PhoneDigit = 8
            Case "W" To "Z"
                PhoneDigit = 9
        End Select
    Else
        PhoneDigit = ""
    End If
End Function

Private Sub cmdDial_Click()
Const MAX_TRIES = 10000

Dim results As String
Dim num_tries As Long

    Screen.MousePointer = vbHourglass
    DoEvents
    On Error GoTo Oops

    ' Try to give MSComm1 time to close.
    If MSComm1.PortOpen = True Then MSComm1.PortOpen = False
    DoEvents

    ' Set the comm port number.
    MSComm1.CommPort = CInt(cboCommPort.Text)

    ' Read the entire buffer when Input is used.
    MSComm1.InputLen = 0

    ' 9600 baud, no parity, 8 data bits, 1 stop bit.
    MSComm1.Settings = "9600,N,8,1"

    ' Open the comm port.
    MSComm1.PortOpen = True

    ' Send the attention string to the modem.
    MSComm1.Output = "ATV1Q0" & Chr$(13)

    ' Wait for OK.
    Do
        ' Read the latest data from the serial port.
        DoEvents
        results = results & MSComm1.Input
        num_tries = num_tries + 1
        If num_tries > MAX_TRIES Then
            MsgBox "Did not get OK response in " & MAX_TRIES & " tries"
            Exit Do
        End If
    Loop Until InStr(results, "OK" & vbCrLf) > 0

    ' Dial the phone number.
    MSComm1.Output = "ATDT " & CleanPhoneNumber(txtPhoneNumber.Text) & vbCr

    ' Ask the user to wait until the phone rings.
    MsgBox "When you hear a busy signal, click OK." & vbCrLf & _
        "When you hear a ringing signal, pick up the receiver and click OK.", _
        vbInformation Or vbOKOnly, "Please Wait"

    ' Close the serial port.
    MSComm1.PortOpen = False
    Screen.MousePointer = vbDefault
    Exit Sub

Oops:
    MsgBox "Error " & Err.Number & vbCrLf & _
        Err.Description, _
        vbExclamation Or vbOKOnly, _
        "Error"
    Screen.MousePointer = vbDefault
    Exit Sub
End Sub

Private Sub Form_Load()
    cboCommPort.Text = 3
End Sub


